#include <iostream>
#include <cstdlib>
#include <string>
#include <unistd.h>
#include <dlfcn.h>

#ifndef RTLD_GLOBAL
# define RTLD_GLOBAL 0
#endif

int 
main (int argc, char *argv[])
{
  
  // setup the path variable so that dlopen finds the directory.
  string newpath ("PATH=");
  newpath += DLL_DIR;
  newpath += ":";
  newpath += getenv ("PATH");
  putenv (newpath.c_str());
  cerr << "New path: " << newpath << endl;

  const string dllname ("dll-example.dll");

  void* dll_handle = dlopen (dllname.c_str(), RTLD_LAZY | RTLD_GLOBAL);
  if (! dll_handle)
    {
      cerr << dlerror () << endl;
      exit (1);
    }
  
  cout << "DLL handle " << hex << dll_handle << endl; 
  
  typedef int (*ifp) (int);
  ifp funcp = (ifp) dlsym (dll_handle, "dll_func_int");
  if (! funcp)
    {
      cerr << dlerror () << endl;
      exit (1);
    }
  
  cout << "Calling `dll_func_int' from shared object `" << dllname
    << "'" << endl;

  int value = (*funcp) (3);
  cout << "Return value: " << value << endl;

  exit (0);
}

